
;source file for CapsLock program - DednDave 4-2011

;########################################################################

        INCLUDE CapsLock.inc

;########################################################################

;tooltip delay times

DT_Show         EQU 2500  ;duration to show in mS
DT_Initial      EQU 100   ;duration before show in mS
DT_Reshow       EQU 200   ;duration before reshow in mS

;########################################################################

        .DATA

InitFlag        dd 0
ErrCode         dd 0

szTitle         db 'Caps Lock State Demo',0
szTTClass       db 'tooltips_class32',0
MsgEcTt0        db 'Caps Lock is On',0
MsgEcTt1        db 'Having Caps Lock on may cause you to enter your User ID incorrectly.',0
MsgEcTt2        db 'Having Caps Lock on may cause you to enter your Password incorrectly.',0

ErrStr          db 'Error '
ErrBuf          db 8 dup(0),' at Address '
AdrBuf          db 9 dup(0)

;************************************************************************

        .DATA?

hDlg            dd ?
hInstance       dd ?
hStatic         dd ?
hHook           dd ?
CapsState       dd ?
FocusHandle     dd ?
ErrAddr         dd ?
pointer			POINT	<>

ecs1 EditCtrlStruc <>
ecs2 EditCtrlStruc <>

;########################################################################

        .CODE

DlgProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
	cmp     ecx,WM_KEYDOWN
        jz      dProc4

        cmp     ecx,WM_COMMAND
        jnz     dProc6

;-----------------------------------------

;WM_COMMAND

;wParam low word = control identifier
;wParam high word = notification code
;lParam = control handle

        movzx   ecx,word ptr wParam+2  ;convert lParam high word to dword
        mov     edx,lParam             ;EDX = hEdit
        cmp     ecx,EN_SETFOCUS
        jz      dProc0

        cmp     ecx,EN_KILLFOCUS
        jnz     dProc7

;WM_COMMAND:EN_KILLFOCUS

        cmp     edx,FocusHandle
        jnz     dProc7

        mov     FocusHandle,0
        jmp     dProc7

;WM_COMMAND:EN_SETFOCUS

dProc0: cmp     edx,FocusHandle
        jz      dProc7

        mov     FocusHandle,edx

;WM_KEYDOWN, wParam = VK_CAPITAL

dProc1: 
		invoke GetCursorPos,addr pointer
		mov		ecx,pointer.x
		mov		edx,pointer.y
		invoke	SetCursorPos,Ecx,Edx
		mov     ecx,FocusHandle
        mov     edx,ecs1.hTool
        mov     eax,ecs2.hTool
        jecxz   dProc2

        cmp     ecx,ecs1.hEdit
        mov     ecx,CapsState
        jz      dProc2

        xchg    eax,edx

dProc2: push    eax
        push    edx
        push    ecx
        INVOKE  SendMessage,edx,TTM_ACTIVATE,ecx,0
        pop     ecx
        pop     edx
        jecxz   dProc3

;attempt at forcing tooltip popup when activated
;we get the window rectangle for the edit control
;convert that to hDlg client coordinates
;put the top/left corner into a single dword
;add 4 to both X and Y, so it's inside the control
;then, use that point as the mouse position for WM_MOUSEHOVER
;looks good on paper
;but, doesn't always work when caps lock is turned on

        push    edx
        sub     esp,16
        INVOKE  GetWindowRect,edx,esp
        INVOKE  ScreenToClient,hDlg,esp
        mov     eax,[esp+4]
        mov     [esp+2],ax
        pop     eax
        add     esp,12
        add     eax,40004h
        pop     edx
        INVOKE  SendMessage,edx,WM_MOUSEHOVER,0,eax

dProc3: pop     eax
        INVOKE  SendMessage,eax,TTM_ACTIVATE,FALSE,0
        jmp short dProc7

;-----------------------------------------

;WM_KEYDOWN

dProc4: mov     ecx,wParam
        cmp     ecx,VK_CAPITAL
        jz      dProc1

        cmp     ecx,VK_RETURN
        jnz     dProc7

;WM_KEYDOWN, wParam = VK_RETURN

        mov     edx,FocusHandle
        mov     eax,ecs2.hEdit
        cmp     edx,ecs1.hEdit
        jz      dProc5

        mov     ecx,hStatic
        cmp     eax,edx
        jnz     dProc7

        xchg    eax,ecx

dProc5: INVOKE  SetFocus,eax
        jmp     dProc7

;-----------------------------------------

dProc6: cmp     ecx,WM_SIZE
        jz      dProc8

        cmp     ecx,WM_INITDIALOG
        jz      dProc9

        cmp     ecx,WM_CLOSE
        jz      dProcA

dProc7: xor     eax,eax  
        ret

;-----------------------------------------

;WM_SIZE

;we use WM_SIZE to tell us when the dialog
;box has been displayed for the first time
;otherwise, we get no tooltip activation for the first set focus

dProc8: cmp     ecx,InitFlag
        jz      dProc7

        mov     InitFlag,ecx
        jmp     dProc1

;-----------------------------------------

;WM_INITDIALOG

dProc9: push    ebx
        push    esi
        mov     ebx,hWnd
        push    edi
        mov     hDlg,ebx
        INVOKE  SetWindowText,ebx,offset szTitle
        INVOKE  LoadIcon,hInstance,IDI_ICON 
        xchg    eax,edi
        mov     esi,WM_SETICON
        INVOKE  PostMessage,ebx,esi,ICON_SMALL,edi
        INVOKE  PostMessage,ebx,esi,ICON_BIG,edi
        INVOKE  GetDlgItem,ebx,IDC_STC1
        mov     hStatic,eax

;**********************************

;initialize CapsState variable

        xor     edi,edi
        INVOKE  GetKeyState,VK_CAPITAL
        and     eax,1
        mov     CapsState,eax

;insert keyboard hook

        INVOKE  GetCurrentThreadId
        INVOKE  SetWindowsHookEx,WH_KEYBOARD,KeyboardProc,edi,eax
        mov     hHook,eax

;create tooltips

        mov     esi,offset ecs1
        mov     eax,IDC_EDT1
        mov     [esi].EditCtrlStruc.lpTtText,offset MsgEcTt1
        call    TtCreate
        mov     FocusHandle,eax
        INVOKE  SetFocus,eax
        mov     esi,offset ecs2
        mov     eax,IDC_EDT2
        mov     [esi].EditCtrlStruc.lpTtText,offset MsgEcTt2
        call    TtCreate
;        INVOKE  SendMessage,eax,EM_SETPASSWORDCHAR,'*',edi					;COMENTEI AQUI

;**********************************

        pop     edi
        pop     esi
        pop     ebx
        jmp     dProc7

;-----------------------------------------

;WM_CLOSE

;**********************************

;remove keyboard hook

dProcA: INVOKE  UnhookWindowsHookEx,hHook

;**********************************

        INVOKE  EndDialog,hWnd,0
        jmp     dProc7

DlgProc ENDP

;************************************************************************

Bin2Hex PROC uses edi dwVal:DWORD,lpBuffer:DWORD

;always writes 8 bytes: Buffer must be at least that length
;does not terminate the string
;returns ECX = 0

        mov     edi,lpBuffer
        mov     edx,dwVal
        mov     ecx,8

B2Hex0: xor     eax,eax
        shld    eax,edx,4
        shl     edx,4
        cmp     al,0Ah
        sbb     al,69h
        das
        stosb
        loop    B2Hex0

        ret

Bin2Hex ENDP

;************************************************************************

ErrReport PROC

        push    edi
        INVOKE  Bin2Hex,ErrCode,offset ErrBuf
        INVOKE  Bin2Hex,ErrAddr,offset AdrBuf
        sub     esp,508
        push    ecx
        mov     edi,esp
        INVOKE  FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,ecx,ErrCode,ecx,edi,512,ecx
        INVOKE  MessageBox,NULL,edi,offset ErrStr,MB_ICONERROR
        add     esp,512
        pop     edi
        ret

ErrReport ENDP

;************************************************************************

LastErr PROC

;Call With: EAX = error code; if 0, GetLastError will be used
;
;  Returns: EDX = 0 if a previous error occured (current error ignored)
;               = stored error address if current error was recorded

        xor     edx,edx
        cmp     edx,ErrCode
        jnz     ErExit

        or      eax,eax
        jnz     ErrSet

        INVOKE  GetLastError

ErrSet: mov     ErrCode,eax
        mov     edx,[esp]         ;RET address
        sub     edx,14            ;(call/or eax,eax/jnz xx/call) length
        mov     ErrAddr,edx

ErExit: push    edx
        INVOKE  SetLastError,0
        pop     edx
        ret

LastErr ENDP

;************************************************************************

KeyboardProc PROC nCode:SDWORD,wParam:WPARAM,lParam:LPARAM

;keyboard hook proc

        test byte ptr nCode+3,80h       ;if nCode is negative, call next hook
        jz      kProc1

kProc0: INVOKE  CallNextHookEx,hHook,nCode,wParam,lParam
        ret

kProc1: test byte ptr lParam+3,40h      ;only key down - not key up
        jnz     kProc0

        mov     ecx,wParam
        cmp     ecx,VK_CAPITAL          ;caps lock key
        jz      kProc2

        cmp     ecx,VK_RETURN           ;enter key
        jnz     kProc0

        jmp short kProc3

kProc2: push    ecx
        INVOKE  GetKeyState,eCx
        and     eax,1                   ;"toggle state" bit only
        pop     ecx
        mov     CapsState,eax

kProc3: INVOKE  SendMessage,hDlg,WM_KEYDOWN,ecx,lParam
        jmp     kProc0

KeyboardProc ENDP

;************************************************************************

TtCreate PROC

;create a tooltip window

;Call With: EAX = edit box control ID
;           EBX = hDlg
;           ESI = address of edit control structure
;           EDI = 0
;
;  Returns: EAX = hEdit if no error, 0 if error
;           ESI = hTool tooltip handle

        INVOKE  GetDlgItem,ebx,eax
        mov     [esi].EditCtrlStruc.hEdit,eax
        push    eax
        INVOKE  CreateWindowEx,WS_EX_TOOLWINDOW or WS_EX_TOPMOST,offset szTTClass,edi,WS_POPUP or TTS_BALLOON,
                CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,ebx,edi,hInstance,edi
        or      eax,eax
        jnz     Creat0

        call    LastErr
        jmp     Creat1

Creat0: mov     [esi].EditCtrlStruc.hTool,eax
        push    edi                                                ;TOOLINFO.lParam
        push    [esi].EditCtrlStruc.lpTtText                       ;TOOLINFO.lpszText
        push    hInstance                                          ;TOOLINFO.hInst
        push    edi                                                ;TOOLINFO.rect.bottom
        push    edi                                                ;TOOLINFO.rect.right
        push    edi                                                ;TOOLINFO.rect.top
        push    edi                                                ;TOOLINFO.rect.left
        push    [esi].EditCtrlStruc.hEdit                          ;TOOLINFO.uId
        push    ebx                                                ;TOOLINFO.hWnd
        push    TTF_IDISHWND or TTF_SUBCLASS or TTF_UNDOCFLAG      ;TOOLINFO.uFlags
        push    sizeof TOOLINFO                                    ;TOOLINFO.cbSize
        INVOKE  SendMessage,eax,TTM_ADDTOOL,edi,esp
        add     esp,sizeof TOOLINFO
        or      eax,eax
        jnz     Creat2

        call    LastErr
        or      edx,edx
        jz      Creat1

        sub     edx,3              ;length of (add esp,sizeof TOOLINFO) instruction
        mov     ErrAddr,edx        ;adjust error address

Creat1: xor     eax,eax
        pop     edx
        jmp short Creat3

Creat2: mov     esi,[esi].EditCtrlStruc.hTool
        INVOKE  SendMessage,esi,TTM_SETTITLE,TTI_WARNING,offset MsgEcTt0
        INVOKE  SendMessage,esi,TTM_SETMAXTIPWIDTH,edi,180
        INVOKE  SendMessage,esi,TTM_SETDELAYTIME,TTDT_AUTOPOP,DT_Show     ;duration to show in mS
        INVOKE  SendMessage,esi,TTM_SETDELAYTIME,TTDT_INITIAL,DT_Initial  ;duration before show in mS
        INVOKE  SendMessage,esi,TTM_SETDELAYTIME,TTDT_RESHOW,DT_Reshow    ;duration before reshow in mS
        INVOKE  SendMessage,esi,TTM_ACTIVATE,edi,edi
        pop     eax

Creat3: ret

TtCreate ENDP

;************************************************************************

_main   PROC

        xor     edi,edi
        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        or      eax,eax
        jnz     main00

        call    LastErr
        jmp short main01

main00: INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDD_DIALOG1,edi,DlgProc,edi
        cmp     edi,ErrCode
        jz      main02

main01: call    ErrReport

main02: INVOKE  ExitProcess,ErrCode

_main   ENDP

;########################################################################

        END     _main

